; Compiled with: PIC Simulator IDE v7.43
; Microcontroller model: PIC16F819
; Clock frequency: 8.0MHz
;
	R0L EQU 0x020
	R0H EQU 0x021
	R1L EQU 0x022
	R1H EQU 0x023
	R2L EQU 0x024
	R2H EQU 0x025
	R3L EQU 0x026
	R3H EQU 0x027
	R4L EQU 0x028
	R4H EQU 0x029
	R0HL EQU 0x020
	R1HL EQU 0x022
	R2HL EQU 0x024
	R3HL EQU 0x026
	R4HL EQU 0x028
	R1HL0HL EQU 0x020
	R3HL2HL EQU 0x024
	LONG_0 EQU 0x02A
	LONG_1 EQU 0x02B
	LONG_2 EQU 0x02C
	LONG_3 EQU 0x02D
	LONG2_0 EQU 0x02E
	LONG2_1 EQU 0x02F
	LONG2_2 EQU 0x030
	LONG2_3 EQU 0x031
	LONG1 EQU 0x02A
	LONG2 EQU 0x02E
;       The address of 'freq' (word) (global) is 0x03B
;       The address of 'f5' (word) (global) is 0x04A
;       The address of 'fshow' (word) (global) is 0x03F
;       The address of 'fmod' (byte) (global) is 0x03D
;       The address of 'fhbyte' (byte) (global) is 0x041
;       The address of 'flbyte' (byte) (global) is 0x043
;       The address of 'change' (bit) (global) is 0x044,0
;       The address of 'tm' (byte) (global) is 0x03E
;       The address of 't2' (byte) (global) is 0x047
;       The address of 'vu' (byte) (global) is 0x042
;       The address of 'power_1' (word) (global) is 0x045
;       The address of 'power_show' (byte) (global) is 0x048
;       The address of 'power_mod' (byte) (global) is 0x049
;       The address of 'ce' (bit) (global) is 0x006,5
;       The address of 'ck' (bit) (global) is 0x006,4
;       The address of 'da' (bit) (global) is 0x006,6
;       The address of 'tx_en' (bit) (global) is 0x006,7
;       The address of 'dn' (bit) (global) is 0x005,0
;       The address of 'up' (bit) (global) is 0x005,1
;       The address of 'lock' (bit) (global) is 0x005,4
	ORG 0x0000
	BCF PCLATH,4
	BCF PCLATH,3
	GOTO L0002
	ORG 0x0004
	RETFIE
; User code start
L0002:
; 1: 
; 2: '--------------Transmissor FM - PIC16F819 & SAA1057--------------------------------
; 3: 'Declare LCD 16x2
; 4: Define LCD_BITS = 4
; 5: Define LCD_DREG = PORTB
; 6: Define LCD_DBIT = 0
; 7: Define LCD_RSREG = PORTA  'For lcd rs
; 8: Define LCD_RSBIT = 2
; 9: Define LCD_EREG = PORTA  'For lcd e
; 10: Define LCD_EBIT = 3
; 11: Define LCD_RWREG = 0  'LCD RW
; 12: Define LCD_RWBIT = 0  'RWBIT
; 13: 
; 14: '---------------------Delay for LCD -----------------
; 15: Define LCD_COMMANDUS = 5000  'delay after LCDCMDOUT, default value is 5000
; 16: Define LCD_DATAUS = 50  'delay after LCDOUT, default value is 50
; 17: Define LCD_INITMS = 100  'delay used by LCDINIT, default value is 100
; 18: '---------------------Declare PORT ce, ck, da to Connection to Pin SAA1057--------------------------
; 19: Symbol ce = PORTB.5  'IC PLL SAA1057 CE,CK,DA
; 20: Symbol ck = PORTB.4
; 21: Symbol da = PORTB.6
; 22: 
; 23: Symbol tx_en = PORTB.7  'TX output to drive VDD to ON the power supply stable
; 24: Symbol dn = PORTA.0  'Button Decrease Frequency or Power
; 25: Symbol up = PORTA.1  'Button Increase Frequency or Power
; 26: Symbol lock = PORTA.4  'Send data IC PLL for LOCK
; 27: 
; 28: '---------------------Declaration -------------------------------------
; 29: Dim freq As Word
; 30: Dim f5 As Word
; 31: Dim fshow As Word
; 32: Dim fmod As Byte
; 33: Dim fhbyte As Byte
; 34: Dim flbyte As Byte
; 35: Dim change As Bit
; 36: Dim tm As Byte
; 37: Dim t2 As Byte
; 38: Dim vu As Byte
; 39: Dim power_1 As Word  'NAME "Power"  I GOT ERROR HERE WHAT IS THAT AN ERROR
; 40: Dim power_show As Byte
; 41: Dim power_mod As Byte
; 42: 
; 43: ADCON1 = 0x06
	MOVLW 0x06
	BSF STATUS,RP0
	MOVWF ADCON1
	BCF STATUS,RP0
; 44: 
; 45: TRISB = %01000000  'PORTB 6 output, other are input
	MOVLW 0x40
	BSF STATUS,RP0
	MOVWF TRISB
	BCF STATUS,RP0
; 46: 
; 47: TRISA = %11110011  'PORTA 2&3 output, other are input
	MOVLW 0xF3
	BSF STATUS,RP0
	MOVWF TRISA
	BCF STATUS,RP0
; 48: '-----PLL data status----------------------------------------------------------------------
; 49: ce = 0  'CE=0 ck = 0 'CK=0 da = 0 'DA=0
	BCF PORTB,5
; 50: tx_en = 0  'Status TX OFF
	BCF PORTB,7
; 51: 
; 52: Lcdinit  'Initialisation of LCD
	BCF PORTA,3
	BCF PORTA,2
	BSF STATUS,RP0
	BCF TRISA,3
	BCF TRISA,2
	MOVLW 0xF0
	ANDWF TRISB,F
	BCF STATUS,RP0
	MOVLW 0x64
	MOVWF R0L
	CLRF R0H
	CALL W001
	MOVLW 0x33
	CALL LC00
	MOVLW 0xCE
	MOVWF R4L
	MOVLW 0x07
	MOVWF R4H
	CALL DL02
	MOVLW 0x33
	CALL LC00
	MOVLW 0x83
	MOVWF R4L
	CALL DL01
	MOVLW 0x33
	CALL LC00
	MOVLW 0x83
	MOVWF R4L
	CALL DL01
	MOVLW 0x22
	CALL LC00
	MOVLW 0x83
	MOVWF R4L
	CALL DL01
	MOVLW 0x28
	CALL LC02
	MOVLW 0x0C
	CALL LC02
	MOVLW 0x01
	CALL LC02
; 53: Lcdcmdout LcdClear  'Clear LCD
	MOVLW 0x01
	CALL LC02
; 54: 
; 55: Lcdout " FM PLL 5 W "  'Write on display
	MOVLW 0x20
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x50
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x35
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x57
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 56: WaitMs 3000  'Waiting for 3 second
	MOVLW 0xB8
	MOVWF R0L
	MOVLW 0x0B
	MOVWF R0H
	CALL W001
; 57: 
; 58: change = 1  'Change to up
	BSF 0x044,0
; 59: 
; 60: '------Write on EEPROM 10-11-----------
; 61: Read 10, freq.LB
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03B
; 62: Read 11, freq.HB
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03C
; 63: 
; 64: '----------Set frequency 108.0 MHz =1080  2=2160-----------
; 65: If freq > 2160 Then  'if more than 108 Mhz
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x70
	MOVWF R1L
	MOVLW 0x08
	MOVWF R1H
	CALL C003
	BTFSS STATUS,Z
	GOTO L0003
; 66: freq = 1750  'then frequency 87.5 MHz
	MOVLW 0xD6
	MOVWF 0x03B
	MOVLW 0x06
	MOVWF 0x03C
; 67: Write 10, freq.LB  'Write Byte low
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03B,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0004:	BTFSC EECON1,WR
	GOTO L0004
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 68: Write 11, freq.HB  'Write Byte high
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03C,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0005:	BTFSC EECON1,WR
	GOTO L0005
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 69: Endif
L0003:
; 70: 
; 71: If freq < 1750 Then  'if frequency less than 87.50
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0xD6
	MOVWF R1L
	MOVLW 0x06
	MOVWF R1H
	CALL C004
	BTFSS STATUS,Z
	GOTO L0006
; 72: freq = 2160  'then frequency 108 MHz
	MOVLW 0x70
	MOVWF 0x03B
	MOVLW 0x08
	MOVWF 0x03C
; 73: Write 10, freq.LB  'Write Byte low
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03B,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0007:	BTFSC EECON1,WR
	GOTO L0007
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 74: Write 11, freq.HB  'Write Byte high
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03C,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0008:	BTFSC EECON1,WR
	GOTO L0008
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 75: Endif
L0006:
; 76: '--------------------------------------------------------------------------------------------------
; 77: If da Then  'press Enter
	BTFSS 0x006,6
	GOTO L0009
; 78: Lcdcmdout LcdClear  'LCD Clear
	MOVLW 0x01
	CALL LC02
; 79: Lcdout "Frequency Tuning"  'Write on display
	MOVLW 0x46
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x71
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x63
	CALL LC01
	MOVLW 0x79
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x54
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x67
	CALL LC01
; 80: 
; 81: While da  'ENTER
L0010:
	BTFSS 0x006,6
	GOTO L0011
; 82: WaitMs 30  '20
	MOVLW 0x6E
	MOVWF R4L
	MOVLW 0x17
	MOVWF R4H
	CALL DL02
; 83: Wend
	GOTO L0010
L0011:
; 84: 
; 85: WaitMs 100  'Wait for
	MOVLW 0x1E
	MOVWF R4L
	MOVLW 0x4E
	MOVWF R4H
	CALL DL02
; 86: '--------------------------Read L&H byte-------------------------
; 87: Read 10, freq.LB
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03B
; 88: Read 11, freq.HB
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03C
; 89: '----------Frequency devided---------
; 90: fshow = freq / 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x03F
	MOVF R0H,W
	MOVWF 0x040
; 91: fmod = freq Mod 20
	oshonsoft_tempw_1 EQU 0x04C
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x04C
	MOVF R2H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x03D
; 92: fmod = fmod * 5
	MOVF 0x03D,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x03D
; 93: '-------------------------------------------------------------
; 94: Lcdcmdout LcdHome  'Prepare for LCD Out
	MOVLW 0x02
	CALL LC02
; 95: If fmod < 10 Then
	MOVLW 0x0A
	SUBWF 0x03D,W
	BTFSC STATUS,C
	GOTO L0012
; 96: Lcdout "-------", #fshow, ".0", #fmod, "Mhz "  'Write on LCD
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 97: Else
	GOTO L0013
L0012:
; 98: Lcdout "-------", #fshow, ".", #fmod, "Mhz "  'Write on LCD
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 99: Endif
L0013:
; 100: '--------------------------------------------------------------------------------------------------
; 101: While Not da  'If not enter
L0014:
	BTFSC 0x006,6
	GOTO L0015
; 102: tm = 0  'status 0
	CLRF 0x03E
; 103: 
; 104: '--------------Here are Up button---------------------------------
; 105: 
; 106: If up Then
	BTFSS 0x005,1
	GOTO L0016
; 107: freq = freq + 1
	MOVF 0x03B,W
	ADDLW 0x01
	MOVWF 0x03B
	MOVF 0x03C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x03C
; 108: While up
L0017:
	BTFSS 0x005,1
	GOTO L0018
; 109: 
; 110: tm = tm + 4
	MOVF 0x03E,W
	ADDLW 0x04
	MOVWF 0x03E
; 111: 
; 112: If tm = 64 Then freq = freq + 1
	MOVF 0x03E,W
	SUBLW 0x40
	BTFSS STATUS,Z
	GOTO L0019
	MOVF 0x03B,W
	ADDLW 0x01
	MOVWF 0x03B
	MOVF 0x03C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x03C
L0019:
; 113: If tm = 128 Then freq = freq + 1
	MOVF 0x03E,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0020
	MOVF 0x03B,W
	ADDLW 0x01
	MOVWF 0x03B
	MOVF 0x03C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x03C
L0020:
; 114: If tm = 192 Then freq = freq + 1
	MOVF 0x03E,W
	SUBLW 0xC0
	BTFSS STATUS,Z
	GOTO L0021
	MOVF 0x03B,W
	ADDLW 0x01
	MOVWF 0x03B
	MOVF 0x03C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x03C
L0021:
; 115: If tm = 0 Then freq = freq + 1
	MOVF 0x03E,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0022
	MOVF 0x03B,W
	ADDLW 0x01
	MOVWF 0x03B
	MOVF 0x03C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x03C
L0022:
; 116: If freq > 2160 Then freq = 1750
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x70
	MOVWF R1L
	MOVLW 0x08
	MOVWF R1H
	CALL C003
	BTFSS STATUS,Z
	GOTO L0023
	MOVLW 0xD6
	MOVWF 0x03B
	MOVLW 0x06
	MOVWF 0x03C
L0023:
; 117: 
; 118: fshow = freq / 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x03F
	MOVF R0H,W
	MOVWF 0x040
; 119: fmod = freq Mod 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x04C
	MOVF R2H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x03D
; 120: fmod = fmod * 5
	MOVF 0x03D,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x03D
; 121: 
; 122: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 123: If fmod < 10 Then
	MOVLW 0x0A
	SUBWF 0x03D,W
	BTFSC STATUS,C
	GOTO L0024
; 124: Lcdout "-------", #fshow, ".0", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 125: Else
	GOTO L0025
L0024:
; 126: 
; 127: Endif
L0025:
; 128: Wend
	GOTO L0017
L0018:
; 129: Endif
L0016:
; 130: Lcdout "-------", #fshow, ".", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 131: 
; 132: '----------Here are down button-------------------------
; 133: 
; 134: If dn Then freq = freq - 1
	BTFSS 0x005,0
	GOTO L0026
	MOVLW 0x01
	SUBWF 0x03B,W
	MOVWF 0x03B
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x03C,W
	MOVWF 0x03C
L0026:
; 135: While dn
L0027:
	BTFSS 0x005,0
	GOTO L0028
; 136: 
; 137: tm = tm + 4
	MOVF 0x03E,W
	ADDLW 0x04
	MOVWF 0x03E
; 138: 
; 139: If tm = 64 Then freq = freq - 1
	MOVF 0x03E,W
	SUBLW 0x40
	BTFSS STATUS,Z
	GOTO L0029
	MOVLW 0x01
	SUBWF 0x03B,W
	MOVWF 0x03B
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x03C,W
	MOVWF 0x03C
L0029:
; 140: If tm = 128 Then freq = freq - 1
	MOVF 0x03E,W
	SUBLW 0x80
	BTFSS STATUS,Z
	GOTO L0030
	MOVLW 0x01
	SUBWF 0x03B,W
	MOVWF 0x03B
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x03C,W
	MOVWF 0x03C
L0030:
; 141: If tm = 192 Then freq = freq - 1
	MOVF 0x03E,W
	SUBLW 0xC0
	BTFSS STATUS,Z
	GOTO L0031
	MOVLW 0x01
	SUBWF 0x03B,W
	MOVWF 0x03B
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x03C,W
	MOVWF 0x03C
L0031:
; 142: If tm = 0 Then freq = freq - 1
	MOVF 0x03E,W
	SUBLW 0x00
	BTFSS STATUS,Z
	GOTO L0032
	MOVLW 0x01
	SUBWF 0x03B,W
	MOVWF 0x03B
	MOVLW 0x00
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x03C,W
	MOVWF 0x03C
L0032:
; 143: 
; 144: If freq < 1750 Then freq = 2160
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0xD6
	MOVWF R1L
	MOVLW 0x06
	MOVWF R1H
	CALL C004
	BTFSS STATUS,Z
	GOTO L0033
	MOVLW 0x70
	MOVWF 0x03B
	MOVLW 0x08
	MOVWF 0x03C
L0033:
; 145: 
; 146: fshow = freq / 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x03F
	MOVF R0H,W
	MOVWF 0x040
; 147: fmod = freq Mod 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x04C
	MOVF R2H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x03D
; 148: fmod = fmod * 5
	MOVF 0x03D,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x03D
; 149: 
; 150: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 151: If fmod < 10 Then
	MOVLW 0x0A
	SUBWF 0x03D,W
	BTFSC STATUS,C
	GOTO L0034
; 152: Lcdout "-------", #fshow, ".0", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 153: Else
	GOTO L0035
L0034:
; 154: 
; 155: 'Endif 'Endif Tried to disable it
; 156: Wend
	GOTO L0027
L0028:
; 157: Endif
L0035:
; 158: 
; 159: Lcdout "-------", #fshow, ".", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 160: Wend  'When ENTER Write EEPROM 10-11
	GOTO L0014
L0015:
; 161: 
; 162: Write 10, freq.LB
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03B,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0036:	BTFSC EECON1,WR
	GOTO L0036
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 163: Write 11, freq.HB
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x03C,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0037:	BTFSC EECON1,WR
	GOTO L0037
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 164: change = 1
	BSF 0x044,0
; 165: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 166: Endif  'NAME "Endif"  I GOT ERROR HERE
L0009:
; 167: '---------------------------------------------------------------------------------------------
; 168: TRISB = %00000000  'All PORTB output
	BSF STATUS,RP0
	CLRF TRISB
	BCF STATUS,RP0
; 169: '----------------------------make a loop -------------------------------------------------
; 170: loop:
L0001:
; 171: If change Then  'IC PLL
	BTFSS 0x044,0
	GOTO L0038
; 172: '---------------------------Read EEPROM ---------------------------------------------
; 173: Read 10, freq.LB
	MOVLW 0x0A
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03B
; 174: Read 11, freq.HB
	MOVLW 0x0B
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x03C
; 175: '------------------------------------------------------------------------------------------------
; 176: fshow = freq / 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x03F
	MOVF R0H,W
	MOVWF 0x040
; 177: fmod = freq Mod 20
	MOVF 0x03B,W
	MOVWF R0L
	MOVF 0x03C,W
	MOVWF R0H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x04C
	MOVF R2H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x03D
; 178: fmod = fmod * 5
	MOVF 0x03D,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x03D
; 179: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 180: If fmod < 10 Then
	MOVLW 0x0A
	SUBWF 0x03D,W
	BTFSC STATUS,C
	GOTO L0039
; 181: Lcdout "-------", #fshow, ".0", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 182: Else
	GOTO L0040
L0039:
; 183: Lcdout "-------", #fshow, ".", #fmod, "Mhz "
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVLW 0x2D
	CALL LC01
	MOVF 0x03F,W
	MOVWF 0x038
	MOVF 0x040,W
	MOVWF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x03D,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x4D
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x7A
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 184: Endif
L0040:
; 185: '------------------ IC PLL SAA1057--------------------------------------------------------
; 186: f5 = freq * 5
	MOVF 0x03B,W
	MOVWF R3L
	MOVF 0x03C,W
	MOVWF R3H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x04A
	MOVF R2H,W
	MOVWF 0x04B
; 187: fhbyte = f5.HB
	MOVF 0x04B,W
	MOVWF 0x041
; 188: flbyte = f5.LB
	MOVF 0x04A,W
	MOVWF 0x043
; 189: '-------------------IC PLL --------------------------------------------------------------------
; 190: For t2 = 1 To 2
	MOVLW 0x01
	MOVWF 0x047
L0041:
	MOVF 0x047,W
	SUBLW 0x02
	BTFSS STATUS,C
	GOTO L0042
; 191: da = 0
	BCF PORTB,6
; 192: ck = 0
	BCF PORTB,4
; 193: ce = 0
	BCF PORTB,5
; 194: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 195: ce = 1
	BSF PORTB,5
; 196: ck = 1
	BSF PORTB,4
; 197: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 198: ck = 0
	BCF PORTB,4
; 199: '---------------------------------------Byte ---------------------------------------------------
; 200: For tm = 1 To 8
	MOVLW 0x01
	MOVWF 0x03E
L0043:
	MOVF 0x03E,W
	SUBLW 0x08
	BTFSS STATUS,C
	GOTO L0044
; 201: da = fhbyte.7
	BCF PORTB,6
	BTFSC 0x041,7
	BSF PORTB,6
; 202: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 203: ck = 1
	BSF PORTB,4
; 204: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 205: ck = 0
	BCF PORTB,4
; 206: fhbyte = ShiftLeft(fhbyte, 1)
	MOVF 0x041,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x01
	CALL SL00
	MOVF R0L,W
	MOVWF 0x041
; 207: Next tm
	MOVLW 0x01
	ADDWF 0x03E,F
	BTFSS STATUS,C
	GOTO L0043
L0044:
; 208: '------------------------------------Byte-------------------------------------------------
; 209: For tm = 1 To 8
	MOVLW 0x01
	MOVWF 0x03E
L0045:
	MOVF 0x03E,W
	SUBLW 0x08
	BTFSS STATUS,C
	GOTO L0046
; 210: da = flbyte.7
	BCF PORTB,6
	BTFSC 0x043,7
	BSF PORTB,6
; 211: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 212: ck = 1
	BSF PORTB,4
; 213: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 214: ck = 0
	BCF PORTB,4
; 215: flbyte = ShiftLeft(flbyte, 1)
	MOVF 0x043,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x01
	CALL SL00
	MOVF R0L,W
	MOVWF 0x043
; 216: Next tm
	MOVLW 0x01
	ADDWF 0x03E,F
	BTFSS STATUS,C
	GOTO L0045
L0046:
; 217: '--------------------------------Data status is 0----------------------------
; 218: da = 0
	BCF PORTB,6
; 219: ce = 0
	BCF PORTB,5
; 220: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 221: ck = 1
	BSF PORTB,4
; 222: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 223: ck = 0
	BCF PORTB,4
; 224: Next t2
	MOVLW 0x01
	ADDWF 0x047,F
	BTFSS STATUS,C
	GOTO L0041
L0042:
; 225: '------------Option IC PLL SAA1057----------------
; 226: 'send 1101_1101_1001_0101-Word b-> > saa1057 flbyte = %10010101
; 227: 
; 228: fhbyte = %11011101
	MOVLW 0xDD
	MOVWF 0x041
; 229: da = 0
	BCF PORTB,6
; 230: ck = 0
	BCF PORTB,4
; 231: ce = 0
	BCF PORTB,5
; 232: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 233: ce = 1
	BSF PORTB,5
; 234: ck = 1
	BSF PORTB,4
; 235: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 236: ck = 0
	BCF PORTB,4
; 237: 
; 238: For tm = 1 To 8
	MOVLW 0x01
	MOVWF 0x03E
L0047:
	MOVF 0x03E,W
	SUBLW 0x08
	BTFSS STATUS,C
	GOTO L0048
; 239: da = fhbyte.7
	BCF PORTB,6
	BTFSC 0x041,7
	BSF PORTB,6
; 240: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 241: ck = 1
	BSF PORTB,4
; 242: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 243: ck = 0
	BCF PORTB,4
; 244: fhbyte = ShiftLeft(fhbyte, 1)
	MOVF 0x041,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x01
	CALL SL00
	MOVF R0L,W
	MOVWF 0x041
; 245: Next tm
	MOVLW 0x01
	ADDWF 0x03E,F
	BTFSS STATUS,C
	GOTO L0047
L0048:
; 246: 
; 247: For tm = 1 To 8
	MOVLW 0x01
	MOVWF 0x03E
L0049:
	MOVF 0x03E,W
	SUBLW 0x08
	BTFSS STATUS,C
	GOTO L0050
; 248: da = flbyte.7
	BCF PORTB,6
	BTFSC 0x043,7
	BSF PORTB,6
; 249: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 250: ck = 1
	BSF PORTB,4
; 251: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 252: ck = 0
	BCF PORTB,4
; 253: flbyte = ShiftLeft(flbyte, 1)
	MOVF 0x043,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x01
	CALL SL00
	MOVF R0L,W
	MOVWF 0x043
; 254: Next tm
	MOVLW 0x01
	ADDWF 0x03E,F
	BTFSS STATUS,C
	GOTO L0049
L0050:
; 255: 
; 256: da = 0
	BCF PORTB,6
; 257: ce = 0
	BCF PORTB,5
; 258: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 259: ck = 1
	BSF PORTB,4
; 260: WaitUs 5
	MOVLW 0x01
	MOVWF R4L
	CALL DL01
; 261: ck = 0
	BCF PORTB,4
; 262: '-------------------------------------------------------------------------------------------------
; 263: change = 0
	BCF 0x044,0
; 264: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 265: tx_en = 1  'If ready (TX ON) Endif
	BSF PORTB,7
; 266: '------------------------------------------------------------------------------------------------
; 267: ADCON1 = 0x00
	BSF STATUS,RP0
	CLRF ADCON1
; 268: '------------LCD----------------------------
; 269: '------------Calculation for a VU ----------------------------
; 270: Adcin 0, vu
	BCF ADCON1,ADFM
	BCF ADCON1,ADCS2
	BCF STATUS,RP0
	CLRF R0L
	CALL A001
	MOVF ADRESH,W
	MOVWF 0x042
; 271: vu = vu / 2
	MOVF 0x042,W
	MOVWF R0L
	CLRF R0H
	MOVLW 0x02
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x042
; 272: If vu > 14 Then vu = 14
	MOVF 0x042,W
	SUBLW 0x0E
	BTFSC STATUS,C
	GOTO L0051
	MOVLW 0x0E
	MOVWF 0x042
L0051:
; 273: '--------------------------------------------------------------
; 274: Adcin 1, power_1  'NAME "Power" GET ERROR ---> RF Power Output
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x01
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x045
	MOVF ADRESH,W
	MOVWF 0x046
; 275: '-------Calculation for RF Watt-----------------------
; 276: power_1 = power_1 * power_1
	MOVF 0x045,W
	MOVWF R3L
	MOVF 0x046,W
	MOVWF R3H
	MOVF 0x045,W
	MOVWF R1L
	MOVF 0x046,W
	MOVWF R1H
	CALL M001
	MOVF R2L,W
	MOVWF 0x045
	MOVF R2H,W
	MOVWF 0x046
; 277: power_1 = power_1 / 50
	MOVF 0x045,W
	MOVWF R0L
	MOVF 0x046,W
	MOVWF R0H
	MOVLW 0x32
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x045
	MOVF R0H,W
	MOVWF 0x046
; 278: power_show = power_1 / 10
	MOVF 0x045,W
	MOVWF R0L
	MOVF 0x046,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R0L,W
	MOVWF 0x04C
	MOVF R0H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x048
; 279: power_mod = power_1 Mod 10
	MOVF 0x045,W
	MOVWF R0L
	MOVF 0x046,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x04C
	MOVF R2H,W
	MOVWF 0x04D
	MOVF 0x04C,W
	MOVWF 0x049
; 280: '-------------------------------------------------------------------------------------------------
; 281: ADCON1 = 0x06
	MOVLW 0x06
	BSF STATUS,RP0
	MOVWF ADCON1
	BCF STATUS,RP0
; 282: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 283: For tm = 0 To vu
	CLRF 0x03E
L0052:
	MOVF 0x03E,W
	SUBWF 0x042,W
	BTFSS STATUS,C
	GOTO L0053
; 284: Lcdout ">"
	MOVLW 0x3E
	CALL LC01
; 285: Next tm
	MOVLW 0x01
	ADDWF 0x03E,F
	BTFSS STATUS,C
	GOTO L0052
L0053:
; 286: Lcdout "I              "
	MOVLW 0x49
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 287: '-------------------Status LOCK---------------------
; 288: If Not lock Then
	BTFSC 0x005,4
	GOTO L0054
; 289: WaitMs 3000
	MOVLW 0xB8
	MOVWF R0L
	MOVLW 0x0B
	MOVWF R0H
	CALL W001
; 290: '--------LOCK ------------
; 291: If Not lock Then
	BTFSC 0x005,4
	GOTO L0055
; 292: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 293: Lcdout "U"  'I GOT ERROR HERE
	MOVLW 0x55
	CALL LC01
; 294: change = 1
	BSF 0x044,0
; 295: WaitMs 500
	MOVLW 0xF4
	MOVWF R0L
	MOVLW 0x01
	MOVWF R0H
	CALL W001
; 296: Endif
L0055:
; 297: Endif
L0054:
; 298: '-----------------------------Reading for WATT-----------------------------------------------
; 299: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 300: Lcdout "=     "
	MOVLW 0x3D
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 301: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 302: Lcdout "=", #power_show, ".", #power_mod, "w"
	MOVLW 0x3D
	CALL LC01
	MOVF 0x048,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x2E
	CALL LC01
	MOVF 0x049,W
	MOVWF 0x038
	CLRF 0x039
	CALL _append_lab_0001
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	CALL LC21
	MOVLW 0x77
	CALL LC01
; 303: WaitMs 100
	MOVLW 0x1E
	MOVWF R4L
	MOVLW 0x4E
	MOVWF R4H
	CALL DL02
; 304: Goto loop  'looping
	GOTO L0001
; 305: Endif
L0038:
; 306: '---------------------------------End of CODE---------------------------------------
; End of user code
L0056:	GOTO L0056
; APPEND CODE BEGIN: _routine_ascii_word_
_append_lab_0001:
	BCF STATUS,IRP
	MOVLW 0x32
	MOVWF FSR
	BCF 0x03A,0
	MOVF 0x038,W
	MOVWF R2L
	MOVF 0x039,W
	MOVWF R2H
	MOVLW 0x10
	MOVWF R1L
	MOVLW 0x27
	MOVWF R1H
	CALL _append_lab_0002
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL _append_lab_0002
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL _append_lab_0002
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL _append_lab_0002
	MOVF R2L,W
	CALL _append_lab_0003
	CLRF INDF
	RETURN
_append_lab_0002:
	MOVF R2L,W
	MOVWF R0L
	MOVF R2H,W
	MOVWF R0H
	CALL D001
	MOVF R0L,W
	BTFSC 0x003,2
	GOTO L0057
	BSF 0x03A,0
L0057:
	BTFSS 0x03A,0
	GOTO L0058
_append_lab_0003:
	ADDLW 0x30
	MOVWF INDF
	INCF FSR,f
L0058:
	RETURN
; APPEND CODE END.
;
;
; Delay Routine Byte
; minimal routine execution time: 4s
; routine execution time step: 1.5s
; maximal routine execution time: 385s
DL01:
	DECFSZ R4L,F
	GOTO DL01
	RETURN
; Delay Routine Word
; minimal routine execution time: 7.5s
; routine execution time step: 5s
; maximal routine execution time: 327682.5s
DL02:
	MOVLW 0x01
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO DL02
; Waitms Routine
W001:	MOVLW 0x01
	SUBWF R0L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R0H,F
	BTFSS STATUS,C
	RETURN
	MOVLW 0xC5
	MOVWF R4L
	MOVLW 0x00
	MOVWF R4H
	CALL DL02
	GOTO W001
; Lcdout Routine
LC01:
	MOVWF R3L
	BSF PORTA,2
	MOVF PORTB,W
	MOVWF R3H
	SWAPF R3L,F
	CALL LCX5
	MOVWF PORTB
	CALL LCX1
	MOVF PORTB,W
	MOVWF R3H
	SWAPF R3L,F
	CALL LCX5
	MOVWF PORTB
	CALL LCX1
	MOVLW 0x1F
	MOVWF R4L
	CALL DL01
	RETURN
LCX5:
	MOVLW 0xF0
	ANDWF R3H,F
	MOVF R3L,W
	ANDLW 0x0F
	IORWF R3H,W
	RETURN
LCX1:
	BSF PORTA,3
	NOP
	NOP
	BCF PORTA,3
	NOP
	NOP
	RETURN
; Lcdinit Routine
LC00:
	BCF PORTA,2
	MOVWF R3L
	MOVF PORTB,W
	MOVWF R3H
	CALL LCX5
	MOVWF PORTB
	CALL LCX1
	RETURN
; Lcdcmdout Routine
LC02:
	MOVWF R3L
	BCF PORTA,2
	MOVF PORTB,W
	MOVWF R3H
	SWAPF R3L,F
	CALL LCX5
	MOVWF PORTB
	CALL LCX1
	MOVF PORTB,W
	MOVWF R3H
	SWAPF R3L,F
	CALL LCX5
	MOVWF PORTB
	CALL LCX1
	MOVLW 0xE6
	MOVWF R4L
	MOVLW 0x03
	MOVWF R4H
	CALL DL02
	RETURN
; Lcdout Decimal Conversion Routine
LC21:
	MOVF INDF,W
	BTFSC STATUS,Z
	RETURN
	INCF FSR,F
	CALL LC01
	GOTO LC21
;
;
; Word Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	RETURN
; Word Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	RETURN
; Word ShiftLeft Routine
SL01:	BCF STATUS,C
	RLF R0L,F
	RLF R0H,F
SL00:	ADDLW 0xFF
	BTFSC STATUS,C
	GOTO SL01
	RETURN
; Word Comparison Routine
C001:	MOVLW 0x05
	GOTO C007
C002:	MOVLW 0x02
	GOTO C007
C003:	MOVLW 0x06
	GOTO C007
C004:	MOVLW 0x03
	GOTO C007
C005:	MOVLW 0x04
	GOTO C007
C006:	MOVLW 0x01
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x0B
	MOVWF R4L
	CALL DL01
	BSF ADCON0,GO
A002:
	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN
;
;
; End of listing
	END
